/** RPM SQL Upgrade Script - Version 6.0.7 to Version 6.0.8 **/
/** Run this script for each of your RPM SQL databases **/
/** Change the database name below - RPMDB - to the name of your actual RPM database before running the script **/
/** Click Execute to run the script **/

USE RPMDB
GO

-- 5201, 5963
ALTER TABLE Client Drop Column ClientName
ALTER TABLE Client Drop Column ClientNameFL
GO
ALTER TABLE Client Alter Column MiddleInit nvarchar(50) Null
ALTER TABLE Client Add ClientName AS ((((Isnull([LastName],'') +', ')+isnull([FirstName],''))+' ')+isnull([MiddleInit],''))
ALTER TABLE Client Add ClientNameFL AS ((rtrim((isnull([FirstName],'')+' ')+isnull([MiddleInit],''))+' ')+isnull([LastName],''))
ALTER TABLE Client Add ClientNameFLnoM as isnull([FirstName],'')+' '+isnull([LastName],'')
ALTER TABLE Client Add ClientNameLFnoM AS Isnull([LastName],'') +', '+isnull([FirstName],'')
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER View [dbo].[vwAuthPaymentActive] As
SELECT AuthPayment.AuthPaymentID, AuthPayment.ClientID, Client.ClientType, Client.SupportType,
AuthPayment.VendorID, AuthPayment.TransType, AuthPayment.Subcategory, AuthPayment.PaymentFreq, AuthPayment.PayToClient, 
AuthPayment.EffectiveEndDt, AuthPayment.NextPaymentDt, AuthPayment.PaymentAmt, AuthPayment.MailToClient, 
AuthPayment.CheckMemo, AuthPayment.Notes, AuthPayment.PaymentMethod, 
AuthPayment.BatchCheck, AuthPayment.TotalDue, AuthPayment.RemainingBalance, AuthPayment.AccountID, 
AuthPayment.LastUpdated, AuthPayment.ProcessDate, AuthPayment.SortClient, AuthPayment.VendorAddressID, 
AuthPayment.SortAddr, AuthPayment.Verify, AuthPayment.Verified, AuthPayment.ReceiptReq,
Client.ClientName, Vendor.VendorName, Client.BalanceMin, Client.AcctMgrID,
(CASE WHEN [AuthPayment].[MailToClient] = 1 THEN [Client].[address1] ELSE [VendorAddress].[Address1] END) AS Addr1,
(CASE WHEN [AuthPayment].[MailToClient] = 1 THEN [Client].[address2] ELSE [VendorAddress].[Address2] END) AS Addr2,
(CASE WHEN [AuthPayment].[PayToClient] = 1 THEN (CASE WHEN Len(Client.ClientNameFL) > 50 THEN Left(Client.ClientNameFLnoM, 50) ELSE Client.ClientNameFL END) ELSE [Vendor].[VendorName] END) AS PayTo,
(CASE WHEN [AuthPayment].[MailToClient] = 1 THEN [Client].[City] ELSE [VendorAddress].[City] END) AS xCity,
(CASE WHEN [AuthPayment].[MailToClient] = 1 THEN [Client].[State] ELSE [VendorAddress].[State] END) AS xState,
(CASE WHEN [AuthPayment].[MailToClient] = 1 THEN [Client].[ZipCode] ELSE [VendorAddress].[ZipCode] END) AS xZip,
(CASE WHEN [AuthPayment].[MailToClient] = 1 THEN (CASE WHEN Len(Client.ClientNameFL) > 50 THEN Left(Client.ClientNameFLnoM, 50) ELSE Client.ClientNameFL END) ELSE 
(CASE WHEN [AuthPayment].[VendorAddressID] Is Null THEN Null ELSE [VendorName] END)END) AS MailTo,
[AccountDesc] + ': ' + (CASE WHEN [AccountList].[ClientID] > 0 THEN 'Individual' ELSE 'Mass' END) AS AcctDescType
FROM (((AuthPayment INNER JOIN Client ON AuthPayment.ClientId = Client.ClientId) INNER JOIN (AccountList INNER JOIN ClientAccount ON AccountList.AccountID = ClientAccount.AccountID) ON (AuthPayment.AccountID = ClientAccount.AccountID) AND (AuthPayment.ClientId = ClientAccount.ClientID)) LEFT JOIN Vendor ON AuthPayment.VendorId = Vendor.VendorId) LEFT JOIN VendorAddress ON AuthPayment.VendorAddressID = VendorAddress.VendorAddressID
WHERE (((AuthPayment.NextPaymentDt) Is Not Null) 
AND ((Client.StatusType)='Active') AND ((ClientAccount.InactiveAcct)=0) AND ((AccountList.InactiveMass)=0));
GO

-- 4697
ALTER TABLE Client Add PreferredName nvarchar(50) Null
GO

-- 5430
CREATE TABLE [dbo].[SystemXEFT](
	[SystemXEFTID] [int] IDENTITY(1,1) NOT NULL,
	[XEFTFile] nvarchar(250) NULL,
	[XEFTExportFormat] [smallint] NULL,
	[XEFTAddenda] bit NULL,
	[XEFTNACHAType] [smallint] NULL,
	[XEFTAccountBank] [smallint] NULL,
	[XEFTIndAcct] bit NULL,
 CONSTRAINT [aaaaaSystemXEFT_PK] PRIMARY KEY NONCLUSTERED 
(
	[SystemXEFTID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

INSERT INTO SystemXEFT ( XEFTFile, XEFTExportFormat, XEFTAddenda, XEFTNACHAType, XEFTAccountBank, XEFTIndAcct )
        SELECT [System].XEFTFile, [System].XEFTExportFormat, [System].XEFTAddenda, [System].XEFTNACHAType, 1, 0
        FROM [System]
GO

ALTER TABLE [System] DROP COLUMN [XEFTFile]
ALTER TABLE [System] DROP COLUMN [XEFTExportFormat]
ALTER TABLE [System] DROP COLUMN [XEFTAddenda]
ALTER TABLE [System] DROP COLUMN [XEFTNACHAType]
GO

-- 5938 
ALTER TABLE [Audit] ADD AuditVendorID int NULL
ALTER TABLE [AuditArchive] ADD AuditVendorID int NULL
GO

Update [Audit] Set AuditVendorID = AuditDataTableID WHERE AuditDataTable = 'Vendor'
Update [AuditArchive] Set AuditVendorID = AuditDataTableID WHERE AuditDataTable = 'Vendor'

-- 5942 
Alter Table [Client] Add [BasicNotes] nvarchar(max) Null
GO
ALTER TABLE [Roommate] Alter Column [RoommateNote] nvarchar(max) NULL
ALTER TABLE [Employment] Alter Column [EmploymentNote] nvarchar(max) NULL

-- 5982
INSERT INTO UserSecurity ( UserID, SecurityLevel, ObjectID ) SELECT UserSecurity.UserID, UserSecurity.SecurityLevel, 105 FROM UserSecurity WHERE UserSecurity.ObjectID = 97
INSERT INTO UserSecurity ( UserID, SecurityLevel, ObjectID ) SELECT UserSecurity.UserID, UserSecurity.SecurityLevel, 106 FROM UserSecurity WHERE UserSecurity.ObjectID = 98
GO

--5947
Alter Table [User] Add [HighlightBalLimit] bit NULL
GO
Alter Table [User] Add [HighlightBalMin] bit NULL
GO
UPDATE [User] SET [HighlightBalLimit] = 1, [HighlightBalMin] = 1
GO
Alter Table [System] Add [DefaultOnlyBalMin] bit NULL
GO
Alter Table [System] Add [DefaultOnlyBalLimit] bit NULL
GO
UPDATE [System] SET [DefaultOnlyBalMin] = 0, [DefaultOnlyBalLimit] = 0
GO
UPDATE Client SET BalanceMin = Null Where BalanceMin = 0
GO
UPDATE Client SET BalanceLimit = Null Where BalanceLimit = 0
GO

--5307
Alter TABLE [VendorAddress] Add [AddrPhone] nvarchar(14) Null
GO

--5856
Alter Table [CheckLayout] Add [Signature1AllowUser] bit Null
GO
Alter Table [CheckLayout] Add [Signature2AllowUser] bit Null
GO
Update [CheckLayout] Set Signature1AllowUser = 0, Signature2AllowUser = 0

Alter Table [User] Add [Signature1Location] nvarchar(250)
GO
Alter Table [User] Add [Signature2Location] nvarchar(250)
GO

-- 4978
Insert Into PaymentMethod (PaymentMethod, AmtX, AmtXfer, SelectSchd, SelectInd, SelectRpt, SelectRecRange, Dep, Pmt, Trn, Bal)
    Values ('ATM/Cash', -1, 1, 1, 1, 1, 1, 0, 1, 0, 0)
GO
-- 4557
Insert Into PaymentMethod (PaymentMethod, AmtX, AmtXfer, SelectSchd, SelectInd, SelectRpt, SelectRecRange, Dep, Pmt, Trn, Bal)
    Values ('Credit Card', -1, 1, 1, 1, 1, 1, 0, 1, 0, 0)
GO
Insert Into PaymentMethod (PaymentMethod, AmtX, AmtXfer, SelectSchd, SelectInd, SelectRpt, SelectRecRange, Dep, Pmt, Trn, Bal)
    Values ('Debit Card', -1, 1, 1, 1, 1, 1, 0, 1, 0, 0)
GO

-- 5943
CREATE TABLE [dbo].[ClientExpense](
	[ClientExpenseID] [int] IDENTITY(1,1) NOT NULL,
	[ClientID] [int] NULL,
	[Category] nvarchar(25) NULL,
	[Amount] [money] NULL,
	[UserID] nvarchar(20) NULL,
	[LastUpdated] datetime NULL,
 CONSTRAINT [aaaaaClientExpense_PK] PRIMARY KEY NONCLUSTERED 
(
	[ClientExpenseID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

CREATE NONCLUSTERED INDEX [ClientExpenseClientID] ON [dbo].[ClientExpense]
(
	[ClientID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

ALTER TABLE [dbo].[ClientExpense]  WITH CHECK ADD  CONSTRAINT [ClientExpenseClientID_FK00] FOREIGN KEY([ClientID])
REFERENCES [dbo].[Client] ([ClientId])
ON DELETE CASCADE
GO
ALTER TABLE [dbo].[ClientExpense] CHECK CONSTRAINT [ClientExpenseClientID_FK00]
GO

INSERT INTO UserSecurity ( UserID, SecurityLevel, ObjectID ) SELECT UserSecurity.UserID, UserSecurity.SecurityLevel, 107 FROM UserSecurity WHERE UserSecurity.ObjectID = 104

-- 5994
ALTER TABLE [System] Add [BasicCustom1] nvarchar(15) Null
ALTER TABLE [System] Add [BasicCustom2] nvarchar(15) Null
GO

-- 5949
ALTER TABLE Client Add [Birthplace] nvarchar(50) Null
ALTER TABLE Client Add [MotherMaiden] nvarchar(50) Null
ALTER TABLE Client Add [FatherName] nvarchar(50) Null
ALTER TABLE Client Add [DeathDate] datetime Null
ALTER TABLE Client Add [MarriageDate] datetime Null
ALTER TABLE Client Add [DivorceDate] datetime Null
ALTER TABLE Client Add [SpouseDeathDate] datetime Null
GO

-- 5799
INSERT INTO UserSecurity ( UserID, SecurityLevel, ObjectID ) SELECT UserSecurity.UserID, UserSecurity.SecurityLevel, 108 FROM UserSecurity WHERE UserSecurity.ObjectID = 100
GO
UPDATE UserSecurity Set SecurityLevel = 'None' Where ObjectID = 108
GO
INSERT INTO UserSecurity ( UserID, SecurityLevel, ObjectID ) SELECT UserSecurity.UserID, UserSecurity.SecurityLevel, 109 FROM UserSecurity WHERE UserSecurity.ObjectID = 108
GO

-- 5676
CREATE TABLE [dbo].[UserCommunity](
	[LastUpdated] datetime NOT NULL,
	[NewsDate] datetime NULL,
	[ActivityDate] datetime NULL,
	[NewsDetail] nvarchar(100) NULL,
	[ActivityDetail] nvarchar(100) NULL,
	[NewsUpd] bit NULL,
	[ActivityUpd] bit NULL,
 CONSTRAINT [aaaaaUserCommunity_PK] PRIMARY KEY NONCLUSTERED 
(
	[LastUpdated] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO

INSERT INTO UserCommunity ( LastUpdated ) VALUES ('1/1/2024')
GO

ALTER TABLE [User] Add [CommunityDate] datetime Null
ALTER TABLE [User] Add [CommunityNews] bit NULL
ALTER TABLE [User] Add [CommunityActivity] bit NULL
GO

UPDATE [User] Set CommunityNews = 0, CommunityActivity = 0
GO

-- 5248
ALTER TABLE Vendor Alter Column EmailAddress nvarchar(250) Null

-- Delete error messages more than 3 years old
DELETE FROM ErrorMessages WHERE Error_Date < Dateadd(yyyy, -3, GETDATE())
GO

-- Update version
Update VersionDataSQL Set CurrentVersionNum = 608
Go

